package com.hikcreate.app;

import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.Collections;
import java.util.Properties;

import static sun.misc.Version.println;

/**
 * @author yulong shu
 * @version 1.0
 * @date 2021/6/9 16:18
 */
public class KafkaForword {
    public static void main(String[] args) {
        Logger logger = LogManager.getLogger(KafkaForword.class);
        Properties consumerprops = new Properties();
        consumerprops.put("bootstrap.servers", "slave7:6667,slave8:6667,slave9:6667");
        consumerprops.put("group.id", "jw_forword");
        consumerprops.put("enable.auto.commit", "false");
        consumerprops.put("session.timeout.ms", "30000");
        consumerprops.put("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        consumerprops.put("value.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        consumerprops.put("auto.offset.reset", "latest");
        KafkaConsumer<String, String> consumer = new KafkaConsumer(consumerprops);
        Properties producerprops = new Properties();
        producerprops.put("bootstrap.servers", "10.11.57.119:9092,10.11.57.108:9092,10.11.57.109:9092,10.11.57.110:9092,10.11.57.111:9092");
        producerprops.put("key.serializer", "org.apache.kafka.common.serialization.StringSerializer");
        producerprops.put("value.serializer", "org.apache.kafka.common.serialization.StringSerializer");
        producerprops.put("acks", "1");
        producerprops.put("timeout.ms", "30000");
        producerprops.put("batch.size","1000");
        consumer.subscribe(Collections.singletonList("JW_CREDIT"));
        KafkaProducer<String, String> producer = new KafkaProducer(producerprops);
        logger.info("初始化完成");
        int flag=0;
        try {
            for (; ; ) {
                ConsumerRecords<String, String> records = consumer.poll(1000);
                if (!records.isEmpty() && records.count()>0) {
                    flag=0;
                    logger.info("消费到:" + records.count() + "条数据");
                    for (ConsumerRecord<String, String> record : records) {
                        ProducerRecord<String, String> producerRecord = new ProducerRecord<>("creditScoreTopic", record.value());
                        producer.send(producerRecord);
                    }
                    producer.flush();
                    consumer.commitSync();
                }else{
                    Thread.sleep(1000);
                    flag+=1;
                }
                if(flag>180){
                    logger.info("180s内无kafka消息，退出转发程序");
                    System.exit(0);
                }
            }
        } catch (Exception e) {
            logger.error(e.getMessage(),e);
        } finally {
            if(producer!=null) producer.close();
            if(consumer!=null) consumer.close();
        }
    }
}

